VERSION 5.00
Begin VB.Form FrmDirectX 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "DirectX Demo"
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "FrmDirectX"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************
'
' THIS WORK, INCLUDING THE SOURCE CODE, DOCUMENTATION
' AND RELATED MEDIA AND DATA, IS PLACED INTO THE PUBLIC DOMAIN.
'
' THE ORIGINAL AUTHOR IS RYAN CLARK.
'
' THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY
' OF ANY KIND, NOT EVEN THE IMPLIED WARRANTY OF
' MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE,
' ASSUMES _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE
' RESULTING FROM THE USE, MODIFICATION, OR
' REDISTRIBUTION OF THIS SOFTWARE.
'
'**************************************************************
'
' This file was downloaded from The Game Programming Wiki.
' Come and visit us at http://gpwiki.org
'
'**************************************************************
'
'IMPORTANT TO NOTE:
'
'When using resource files and the CreateSurfaceFromResource
'command in DirectX 7.0, you will not be able to run your program
'by simply pressing F5 or selecting the run menu item, you will
'get an error. dX7 will only recognize your resource file if you
'compile your program and RUN THE COMPILED VERSION.
'
'**************************************************************

Private Sub Form_Load()
    
    DDraw.Initialize            'Initialize DirectDraw
    DInput.Initialize           'Initialize DirectInput
    Me.Show                     'Show the form
    MainLoop                    'Run the main loop

End Sub

Private Sub MainLoop()

    On Error GoTo ErrOut
    
    Do While Running
        HandleKeys              'Check the DirectInput data for significant keypresses
        DDraw.DisplaySprite     'Display the appropriate frame of the sprite
        DDraw.Flip              'Flip the backbuffer to the screen
        DDraw.ClearBuffer       'Erase the backbuffer so that it can be drawn on again
        DoEvents                'Give windows its chance to do things
    Loop
    
ErrOut:

    ExitProgram                 'If an error occurs, leave the program
    
End Sub

Public Sub ExitProgram()

    DDraw.Terminate             'Unload the DirectDraw variables
    DInput.Terminate            'Unload the DirectInput variables
    End                         'End the program
    
End Sub

Private Sub HandleKeys()

    DInput.CheckKeys                                            'Get the current state of the keyboard
    If DInput.aKeys(DIK_ESCAPE) Then Running = False            'Has the escape key been pressed?
    If DInput.aKeys(DIK_UP) Then ColourFill = ColourFill + 1    'Increase the background colour if the up arrow is pressed
    If DInput.aKeys(DIK_DOWN) Then ColourFill = ColourFill - 1  'Decrease the background colour if the down arrow is pressed
    If DInput.aKeys(DIK_I) Then                                 'If the "I" key is pressed, zoom in
        If Zoom > 1 Then Zoom = 1                               'Limit zoom in to 1x
        If Zoom < 1 Then Zoom = Zoom + 0.01
    End If
    If DInput.aKeys(DIK_O) Then                                 'If the "O" key is pressed, zoom out
        If Zoom < 0.1 Then Zoom = 0.1                           'Limit zoom out to 10x
        If Zoom > 0.1 Then Zoom = Zoom - 0.01
    End If
    If DInput.aKeys(DIK_LEFT) Then                              'If the left arrow is pressed, rotate the ship left
        If Facing > 0 Then Facing = Facing - 1                  'If we're above zero, decrease the facing variable
        If Facing = 0 Then Facing = 39                          'If we're at zero, set the facing variable to 39 (the max)
    End If
    If DInput.aKeys(DIK_RIGHT) Then                             'If the right arrow is pressed, rotate the ship right
        If Facing < 39 Then Facing = Facing + 1                 'If we're below 39 then increase the facing variable
        If Facing = 39 Then Facing = 0                          'If we're at 39, set the facing variable to 0 (the min)
    End If

End Sub
